package com.jasamedika.medifirst2000.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapSkriningGiziService;
import com.jasamedika.medifirst2000.vo.PapSkriningGiziVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_ERROR;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for Pengakjian Awal Gawat Darurat Business
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/skrining-gizi")
@JsonIgnoreProperties(ignoreUnknown = true)
public class PapSkriningGiziController extends LocaleController<PapSkriningGiziVO> {

	private static final Logger LOGGER = getLogger(PapSkriningGiziController.class);

	@Autowired
	private PapSkriningGiziService<PapSkriningGiziVO> papSkriningGiziService;

	@RequestMapping(value = "/save-skrining-gizi", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> savePasien(@Valid @RequestBody PapSkriningGiziVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = papSkriningGiziService.addSkriningGizi(vo);
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when addSkriningGizi", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when addSkriningGizi", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/findskoring", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> findSkoring(HttpServletRequest request) {
		Map<String, Object> result = papSkriningGiziService.findSkoring();
		boolean dataFound = (boolean) result.get("dataFound");
		mapHeaderMessage.clear();
		if (dataFound) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
		} else {
			mapHeaderMessage.put(LABEL_ERROR, getMessage(MessageResource.LABEL_ERROR, request));
		}
		return getJsonResponse(result, OK, mapHeaderMessage);
	}

	@RequestMapping(value = "/find-skoring/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> findSkoringParam(
			@RequestParam(value = "dateStart", required = false) String startDate,
			@RequestParam(value = "dateEnd", required = false) String endDate,
			@RequestParam(value = "namaPasien", required = false) String namaPasien,
			@RequestParam(value = "pilih", required = false) String pilih, HttpServletRequest request) {
		String namaPasienBaru = "";
		if (namaPasien != null)
			namaPasienBaru = namaPasien.toLowerCase();
		Map<String, Object> result = papSkriningGiziService.findSkoring(startDate, endDate, namaPasienBaru, pilih);
		boolean dataFound = (boolean) result.get("dataFound");
		mapHeaderMessage.clear();
		if (dataFound) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
		} else {
			mapHeaderMessage.put(LABEL_ERROR, getMessage(MessageResource.LABEL_ERROR, request));
		}
		return getJsonResponse(result, OK, mapHeaderMessage);
	}

}
